From: Andrew Cagney <ac131313@redhat.com>
To: Daniel Jacobowitz <drow@mvista.com>
Cc: gdb-patches@sources.redhat.com
Subject: Re: [patch/rfc] post-process the `maint print architecture' from gdb_mbuild.sh
Date: Wed, 08 Jan 2003 23:59:00 -0000 [thread overview]
Message-ID: <3E1CBB4E.4090405@redhat.com> (raw)
In-Reply-To: <20030107155435.GA12218@nevyn.them.org>
[-- Attachment #1: Type: text/plain, Size: 925 bytes --]
> On Tue, Jan 07, 2003 at 10:10:36AM -0500, Andrew Cagney wrote:
>
>> >>Thoughts?
>
>> >
>> >
>> >The idea sounds good to me.
>> >
>> >Instead of ed'ing Gdb.log, how about just naming the first file
>> >Gdb.out or Gdb-raw.log, and then sed'ing into Gdb.log.
>
>>
>> I can save the unedited output.
>>
>> To make sed worthwhile, I'd need to construct a sed script that did all
>> substitutions in a single pass. Otherwize the script ends up repeating:
>> sed -e ... < input > output
>> mv output input
>> which is equivalent to ed. That, I think, is something for a rainy day.
>
>
> It's as simple as "sed -e ... -e ... -e ... -e ... < input > output",
> isn't it? Or via -f and a file, the same thing.
Yes - `construct a sed script'. I've done it (attached, committed).
Doesn't make it any faster though. The slow bit is:
+ func="`addr2line -f -e ./gdb/gdb -s ${addr} | sed -n -e 1p`"
enjoy,
Andrew
[-- Attachment #2: diffs --]
[-- Type: text/plain, Size: 1589 bytes --]
2003-01-08 Andrew Cagney <ac131313@redhat.com>
* gdb_mbuild.sh: Edit the output of `maint print architecture'
replacing hex constants with function names and stripping leading
file name directory prefixes.
Index: gdb_mbuild.sh
===================================================================
RCS file: /cvs/src/src/gdb/gdb_mbuild.sh,v
retrieving revision 1.3
diff -u -r1.3 gdb_mbuild.sh
--- gdb_mbuild.sh 2 Jan 2003 16:40:33 -0000 1.3
+++ gdb_mbuild.sh 8 Jan 2003 23:46:52 -0000
@@ -279,12 +279,32 @@
fail "gdb printed no output" ! -s Gdb.log
grep -e internal-error Gdb.log && fail "gdb panic" 1
+ echo ... cleanup ${target}
+
+ # Create a sed script that cleans up the output from GDB.
+ rm -f mbuild.sed
+ touch mbuild.sed || exit 1
+
+ # Rules to replace <0xNNNN> with the corresponding function's
+ # name.
+ sed -n -e '/<0x0*>/d' -e 's/^.*<0x\([0-9a-f]*\)>.*$/0x\1/p' Gdb.log \
+ | sort -u \
+ | while read addr
+ do
+ func="`addr2line -f -e ./gdb/gdb -s ${addr} | sed -n -e 1p`"
+ test ${verbose} -gt 0 && echo "${addr} ${func}" 1>&2
+ echo "s/<${addr}>/<${func}>/g"
+ done >> mbuild.sed
+
+ # Rules to strip the leading paths off of file names.
+ echo 's/"\/.*\/gdb\//"gdb\//g' >> mbuild.sed
+
# Replace the build directory with a file as semaphore that stops
# a rebuild. (should the logs be saved?)
cd ${builddir}
rm -f ${target}.tmp
- mv ${target}/Gdb.log ${target}.tmp
+ sed -f ${target}/mbuild.sed ${target}/Gdb.log > ${target}.tmp
rm -rf ${target}
mv ${target}.tmp ${target}
next prev parent reply other threads:[~2003-01-08 23:59 UTC|newest]
Thread overview: 8+ messages / expand[flat|nested] mbox.gz Atom feed top
2003-01-02 20:04 Michael Elizabeth Chastain
2003-01-07 15:12 ` Andrew Cagney
2003-01-07 15:54 ` Daniel Jacobowitz
2003-01-08 23:59 ` Andrew Cagney [this message]
2003-01-09 0:05 ` Daniel Jacobowitz
-- strict thread matches above, loose matches on Subject: below --
2003-01-07 16:01 Michael Elizabeth Chastain
2003-01-07 15:48 Michael Elizabeth Chastain
2003-01-02 19:48 Andrew Cagney
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=3E1CBB4E.4090405@redhat.com \
--to=ac131313@redhat.com \
--cc=drow@mvista.com \
--cc=gdb-patches@sources.redhat.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox